unit TextForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

const
  w = 383;
  h = 23;
type
  pixelbuf = array[0..w,0..h] of byte;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    FontDialog1: TFontDialog;
    b1: TButton;
    PaintBox1: TPaintBox;
    Edit2: TEdit;
    Edit3: TEdit;
    PaintBox2: TPaintBox;
    Label1: TLabel;
    b4: TButton;
    PaintBox3: TPaintBox;
    PaintBox4: TPaintBox;
    PaintBox5: TPaintBox;
    PaintBox6: TPaintBox;
    Label2: TLabel;
    Label3: TLabel;
    b3: TButton;
    FontDialog2: TFontDialog;
    FontDialog3: TFontDialog;
    b2: TButton;
    Button1: TButton;
    procedure b1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure b4Click(Sender: TObject);
    procedure b3Click(Sender: TObject);
    procedure b2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    s1,s2,s3 : pixelbuf;
    dumpfile : file;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.b1Click(Sender: TObject);
begin
  FontDialog1.Execute;
  Paintbox1.repaint;
end;

procedure TForm1.b2Click(Sender: TObject);
begin
  FontDialog2.Execute;
  Paintbox1.repaint;
end;

procedure TForm1.b3Click(Sender: TObject);
begin
  FontDialog3.Execute;
  Paintbox1.repaint;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var lp1,lp2,pixcount1,pixcount2,pixcount3 : integer;
begin
  Paintbox1.Canvas.FillRect(Paintbox1.Canvas.ClipRect);
  Paintbox2.Canvas.FillRect(Paintbox2.Canvas.ClipRect);
  Paintbox3.Canvas.FillRect(Paintbox3.Canvas.ClipRect);
  Paintbox4.Canvas.FillRect(Paintbox4.Canvas.ClipRect);
  Paintbox5.Canvas.FillRect(Paintbox5.Canvas.ClipRect);
  Paintbox6.Canvas.FillRect(Paintbox6.Canvas.ClipRect);
  Paintbox1.Canvas.Pen.Color := clRed;
  Paintbox3.Canvas.Pen.Color := clRed;
  Paintbox5.Canvas.Pen.Color := clRed;
  for lp1 := 0 to 50 do begin
    Paintbox1.Canvas.Moveto(0,lp1*8);
    Paintbox1.Canvas.Lineto(500,lp1*8);
    Paintbox1.Canvas.Moveto(lp1*128,0);
    Paintbox1.Canvas.Lineto(lp1*128,256);
    Paintbox3.Canvas.Moveto(0,lp1*8);
    Paintbox3.Canvas.Lineto(500,lp1*8);
    Paintbox3.Canvas.Moveto(lp1*128,0);
    Paintbox3.Canvas.Lineto(lp1*128,256);
    Paintbox5.Canvas.Moveto(0,lp1*8);
    Paintbox5.Canvas.Lineto(500,lp1*8);
    Paintbox5.Canvas.Moveto(lp1*128,0);
    Paintbox5.Canvas.Lineto(lp1*128,256);
  end;
  Paintbox1.Canvas.Pen.Color := clBlack;
  Paintbox1.Canvas.Font := FontDialog1.Font;
  PaintBox1.Canvas.TextOut(0,2,Edit1.text);

  Paintbox3.Canvas.Pen.Color := clBlack;
  Paintbox3.Canvas.Font := FontDialog2.Font;
  PaintBox3.Canvas.TextOut(0,-4,Edit2.text);

  Paintbox5.Canvas.Pen.Color := clBlack;
  Paintbox5.Canvas.Font := FontDialog3.Font;
  PaintBox5.Canvas.TextOut(0,-4,Edit3.text);

  pixcount1 := 0; pixcount2 := 0; pixcount3 := 0;
  for lp1:=0 to w do begin
    for lp2:=0 to h do begin
      if PaintBox1.Canvas.Pixels[lp1,lp2]=clblack then begin
        PaintBox2.Canvas.Pixels[lp1,lp2]:=clWhite;
        s1[lp1,lp2] := 1;
        inc(pixcount1);
      end
      else s1[lp1,lp2] := 0;
      if PaintBox3.Canvas.Pixels[lp1,lp2]=clblack then begin
        PaintBox4.Canvas.Pixels[lp1,lp2]:=clWhite;
        s2[lp1,lp2] := 1;
        inc(pixcount2);
      end
      else s2[lp1,lp2] := 0;
      if PaintBox5.Canvas.Pixels[lp1,lp2]=clblack then begin
        PaintBox6.Canvas.Pixels[lp1,lp2]:=clWhite;
        s3[lp1,lp2] := 1;
        inc(pixcount3);
      end
      else s3[lp1,lp2] := 0;
    end;
  end;
  label1.Caption := IntToStr(pixcount1);
  label2.Caption := IntToStr(pixcount2);
  label3.Caption := IntToStr(pixcount3);

  Paintbox1.Canvas.Pen.Color := clRed;
  Paintbox3.Canvas.Pen.Color := clRed;
  Paintbox5.Canvas.Pen.Color := clRed;
  for lp1 := 0 to 50 do begin
    Paintbox1.Canvas.Moveto(0,lp1*8);
    Paintbox1.Canvas.Lineto(500,lp1*8);
    Paintbox1.Canvas.Moveto(lp1*128,0);
    Paintbox1.Canvas.Lineto(lp1*128,256);
    Paintbox3.Canvas.Moveto(0,lp1*8);
    Paintbox3.Canvas.Lineto(500,lp1*8);
    Paintbox3.Canvas.Moveto(lp1*128,0);
    Paintbox3.Canvas.Lineto(lp1*128,256);
    Paintbox5.Canvas.Moveto(0,lp1*8);
    Paintbox5.Canvas.Lineto(500,lp1*8);
    Paintbox5.Canvas.Moveto(lp1*128,0);
    Paintbox5.Canvas.Lineto(lp1*128,256);
  end;
  
end;

procedure TForm1.b4Click(Sender: TObject);
begin
  PaintBox1.repaint;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  assignfile(dumpfile,'..\Zone_Rings_32_Binary.bin');
  rewrite(dumpfile,1);
  blockwrite(dumpfile,s1,sizeof(s1));
  blockwrite(dumpfile,s2,sizeof(s1));
  blockwrite(dumpfile,s3,sizeof(s1));
  closefile(dumpfile);
end;

end.
